// set global vars
var ComboSelectedProjectRoot = "";
var ComboSelectedProjectName = "";
var ini = new TIniFile(Script.GetPath + "projects.ini");
var SL = new TStringList; // section list
var SH = new TStringList; // section headings
var filename = "";
var counter = 0;
var i = 0;

function ProjectManager(Sender) {

    f = new TForm(WeBuilder);
    f.Width = 600;
    f.Height = 670;
    f.BorderStyle = bsSingle; //disable dialog resizing
    f.BorderIcons = biSystemMenu; //remove maximize & minimize buttons
    f.Caption = "Project Manager";

    var pnlCurrentWBProject = new TPanel(f);
    pnlCurrentWBProject.Parent = f;
    pnlCurrentWBProject.BorderWidth = 1;
    pnlCurrentWBProject.BevelKind = 1;
    pnlCurrentWBProject.BorderStyle = 0;
    pnlCurrentWBProject.SetBounds(14, 10, 568, 80);

    var lbCurrentWBProject = new TLabel(f);
    lbCurrentWBProject.Parent = pnlCurrentWBProject;
    lbCurrentWBProject.Caption = "Current project open in WeBuilder:";
    lbCurrentWBProject.SetBounds(8, 14, 500, 15);

    var editCurrentWBProject = new TEdit(f);
    editCurrentWBProject.Parent = pnlCurrentWBProject;
    editCurrentWBProject.SetBounds(190, 10, 240, 45);
    editCurrentWBProject.Text = Script.ProjectSettings.SelectedProjectName;

    var btnOpenFileList = new TButton(f);
    btnOpenFileList.Parent = pnlCurrentWBProject;
    btnOpenFileList.SetBounds(8, 40, 90, 25);
    btnOpenFileList.Caption = "Open File List";
    btnOpenFileList.OnClick = &OpenFileList;

    var btnCloseOtherProjects = new TButton(f);
    btnCloseOtherProjects.Parent = pnlCurrentWBProject;
    btnCloseOtherProjects.SetBounds(108, 40, 120, 25);
    btnCloseOtherProjects.Caption = "Close Other Projects";
    btnCloseOtherProjects.OnClick = &CloseOtherProjects;

    var btnCloseallAndOpenFileList = new TButton(f);
    btnCloseallAndOpenFileList.Parent = pnlCurrentWBProject;
    btnCloseAllAndOpenFileList.SetBounds(238, 40, 150, 25);
    btnCloseAllAndOpenFileList.Caption = "Close All And Open File List";
    btnCloseallAndOpenFileList.OnClick = &CloseOtherProjectsOpenFileList;

    var btnSaveProject = new TButton(f);
    btnSaveProject.Parent = pnlCurrentWBProject;
    btnSaveProject.SetBounds(398, 40, 100, 25);
    btnSaveProject.Caption = "Save Project";
    btnSaveProject.OnClick = &SaveProject;

    var lblOptionsChangeProject = new TLabel(f);
    lblOptionsChangeProject.Parent = f;
    lblOptionsChangeProject.Caption = "Options when changing projects in WeBuilder:";
    lblOptionsChangeProject.Font.Style = 1;
    lblOptionsChangeProject.SetBounds(14, 100, 500, 15);
    lblOptionsChangeProject.Visible = true;

    var pnlChangeProject = new TPanel(f);
    pnlChangeProject.Parent = f;
    pnlChangeProject.BorderWidth = 1;
    pnlChangeProject.BevelKind = 1;
    pnlChangeProject.BorderStyle = 0;
    pnlChangeProject.SetBounds(14, 120, 280, 50);

    var lblChangeProject = new TLabel(f);
    lblChangeProject.Parent = pnlChangeProject;
    lblChangeProject.Caption = "Open/Close files when changing projects:";
    lblChangeProject.SetBounds(8, 4, 500, 15);

    var radChangeProject1 = new TRadioButton(f);
    radChangeProject1.Parent = pnlChangeProject;
    radChangeProject1.SetBounds(8, 19, 80, 25);
    radChangeProject1.Caption = "Automatically";
    radChangeProject1.OnClick = &OnClick_radChangeProject1;

    var radChangeProject2 = new TRadioButton(f);
    radChangeProject2.Parent = pnlChangeProject;
    radChangeProject2.SetBounds(114, 19, 60, 25);
    radChangeProject2.Caption = "Prompt";
    radChangeProject2.OnClick = &OnClick_radChangeProject2;

    var radChangeProject3 = new TRadioButton(f);
    radChangeProject3.Parent = pnlChangeProject;
    radChangeProject3.SetBounds(194, 19, 60, 25);
    radChangeProject3.Caption = "Manually";
    radChangeProject3.OnClick = &OnClick_radChangeProject3;

    changeProject = ini.ReadString("Settings", "ChangeProject", "");

    if(changeProject == "Automatically")
    {
        radChangeProject1.Checked = true;

    } else if(changeProject == "Prompt") {

        radChangeProject2.Checked = true;

    } else {

        radChangeProject3.Checked = true;
    }

    var pnlUpdateList = new TPanel(f);
    pnlUpdateList.Parent = f;
    pnlUpdateList.BorderWidth = 1;
    pnlUpdateList.BevelKind = 1;
    pnlUpdateList.BorderStyle = 0;
    pnlUpdateList.SetBounds(302, 120, 280, 50);

    var lblUpdateList = new TLabel(f);
    lblUpdateList.Parent = pnlUpdateList;
    lblUpdateList.Caption = "Update files when changing projects:";
    lblUpdateList.SetBounds(8, 4, 500, 15);

    var radUpdateList1 = new TRadioButton(f);
    radUpdateList1.Parent = pnlUpdateList;
    radUpdateList1.SetBounds(8, 19, 80, 25);
    radUpdateList1.Caption = "Automatically";
    radUpdateList1.OnClick = &OnClick_radUpdateList1;

    var radUpdateList2 = new TRadioButton(f);
    radUpdateList2.Parent = pnlUpdateList;
    radUpdateList2.SetBounds(114, 19, 60, 25);
    radUpdateList2.Caption = "Prompt";
    radUpdateList2.OnClick = &OnClick_radUpdateList2;

    var radUpdateList3 = new TRadioButton(f);
    radUpdateList3.Parent = pnlUpdateList;
    radUpdateList3.SetBounds(194, 19, 60, 25);
    radUpdateList3.Caption = "Manually";
    radUpdateList3.OnClick = &OnClick_radUpdateList3;

    updateList = ini.ReadString("Settings", "UpdateList", "");

    if(updateList == "Automatically")
    {
        radUpdateList1.Checked = true;

    } else if(updateList == "Prompt") {

        radUpdateList2.Checked = true;

    } else {

        radUpdateList3.Checked = true;
    }

    var lblManageProject = new TLabel(f);
    lblManageProject.Parent = f;
    lblManageProject.Caption = "Manage existing projects:";
    lblManageProject.Font.Style = 1;
    lblManageProject.SetBounds(12, 180, 500, 15);
    lblManageProject.Visible = true;

    var lblProjects = new TLabel(f);
    lblProjects.Parent = f;
    lblProjects.Caption = "Select Project:";
    lblProjects.SetBounds(14, 210, 500, 15);

    var comboProjects = new TComboBox(f);
    comboProjects.Parent = f;
    comboProjects.SetBounds(95, 206, 200, 24);
    comboProjects.Sorted = true;

    lblCurrentProject = new TLabel(f);
    lblCurrentProject.Parent = f;
    lblCurrentProject.Caption = "(This is also the currently selected project in WeBuilder)";
    lblCurrentProject.SetBounds(304, 210, 500, 15);
    lblCurrentProject.Visible = false;

    comboProjects.Items.Add(""); //add blank entry to dropdown

    // populate comboProjects with previously saved projects
    ini.ReadSections(SH); // get section headings

    if(SH.Count > 0)
    {
        for (i=0; i<=SH.Count-1; i++)
        {
            if(SH[i] != "Settings")
            {
                if(SH[i] != "Projects")
                {
                    comboProjects.Items.Add(SH[i]);
                }
            }
        }

    } else {

        alert("You have no saved projects.");
    }

    var ProjectInList = false; // is the selected project in WB in the list of saved projects?

    for (i=1; i<comboProjects.Items.Count; i++)
    {
        if (comboProjects.Items[i] == Script.ProjectSettings.SelectedProjectName)
        {
            comboProjects.ItemIndex = i; // select found value in dropdown
            projectInList = true;

            ComboSelectedProjectName = Script.ProjectSettings.SelectedProjectName;
            ComboSelectedProjectRoot = ini.ReadString("Projects", ComboSelectedProjectName, "");
        }
    }

    comboProjects.OnChange = &OnChange_comboProjects;

    var lblProjectFiles = new TLabel(f);
    lblProjectFiles.Parent = f;
    lblProjectFiles.Caption = "Existing file list for currently selected project:";
    lblProjectFiles.SetBounds(14, 240, 500, 15);

    // list of files previously saved in Project Manager
    listProjectFiles = new TListBox(f);
    listProjectFiles.Parent = f;
    listProjectFiles.SetBounds(14, 260, 570, 120);

    listProjectFiles.MultiSelect = true;
    listProjectFiles.ExtendedSelect = false;

    // if the currectly selected project in WB has a list of files saved in Project Manager, load them
    if(projectInList == true)
    {
        ini.ReadSection(Script.ProjectSettings.SelectedProjectName, SL);

        if(SL.Count > 0)
        {
            filename = "";

            for (i=0; i<=SL.Count-1; i++)
            {
                filename = ini.ReadString(Script.ProjectSettings.SelectedProjectName, SL[i], "");
                listProjectFiles.Items.Add(filename);
            }
        }

        lblCurrentProject.Visible = true;
    }

    var lblRemove = new TLabel(f);
    lblRemove.Parent = f;
    lblRemove.Caption = "Highlight file(s) to be removed from the selected project";
    lblRemove.SetBounds(14, 390, 500, 15);

    var btnRemove = new TButton(f);
    btnRemove.Parent = f;
    btnRemove.SetBounds(424, 386, 75, 25);
    btnRemove.Caption = "Remove";
    btnRemove.OnClick = &OnClick_btnRemove;

    var btnRemoveAll = new TButton(f);
    btnRemoveAll.Parent = f;
    btnRemoveAll.SetBounds(510, 386, 75, 25);
    btnRemoveAll.Caption = "Remove All";
    btnRemoveAll.OnClick = &OnClick_btnRemoveAll;

    var lblProjectOpen = new TLabel(f);
    lblProjectOpen.Parent = f;
    lblProjectOpen.Caption = "Files open in WeBuilder for this project that are NOT in the above file list:";
    lblProjectOpen.SetBounds(14, 430, 500, 15);

    // displays list of open files NOT in Project Manager list
    listProjectOpen = new TListBox(f);
    listProjectOpen.Parent = f;
    listProjectOpen.SetBounds(14, 450, 570, 120);

    listProjectOpen.MultiSelect = true;
    listProjectOpen.ExtendedSelect = false;

    //listProjectOpen.Items.Clear;
    if(projectInList == true)
    {
        counter = 0;
        filename = "";

        for (i=0; i<Documents.Count; i++)
        {
            var doc = Documents.Tab[i];
            filename = doc.FileName;

            if (Lowercase(copy(filename, 1, Length(Script.ProjectSettings.SelectedProjectRoot))) == Lowercase(Script.ProjectSettings.SelectedProjectRoot))
            {
                if (listProjectFiles.Items.IndexOf(filename) == -1)
                {
                    listProjectOpen.Items.Add(filename);
                }

                counter++;
            }
        }
    }

    var lblAdd = new TLabel(f);
    lblAdd.Parent = f;
    lblAdd.Caption = "Highlight file(s) to be added to the selected project";
    lblAdd.SetBounds(14, 580, 500, 15);

    var btnAdd = new TButton(f);
    btnAdd.Parent = f;
    btnAdd.SetBounds(424, 576, 75, 25);
    btnAdd.Caption = "Add";
    btnAdd.OnClick = &OnClick_btnAdd;

    var btnAddAll = new TButton(f);
    btnAddAll.Parent = f;
    btnAddAll.SetBounds(510, 576, 75, 25);
    btnAddAll.Caption = "Add All";
    btnAddAll.OnClick = &OnClick_btnAddAll;

    var lblImmediateSave = new TLabel(f);
    lblImmediateSave.Parent = f;
    lblImmediateSave.Caption = "Note: all actions performed here are automatically and immediately saved.";
    lblImmediateSave.SetBounds(14, 620, 500, 15);

    var btnClose = new TButton(f);
    btnClose.Parent = f;
    btnClose.SetBounds(510, 610, 75, 25);
    btnClose.Caption = "Close";
    btnClose.ModalResult = mrOk;

    var r = f.ShowModal;
    delete f;

}

// EXTERNAL FUNCTIONS
// save values of radio button to ini when selected
function OnClick_radChangeProject1(Sender) {

    ini.WriteString("Settings", "ChangeProject", "Automatically");
}

function OnClick_radChangeProject2(Sender) {

    ini.WriteString("Settings", "ChangeProject", "Prompt");
}

function OnClick_radChangeProject3(Sender) {

    ini.WriteString("Settings", "ChangeProject", "Manually");
}

function OnClick_radUpdateList1(Sender) {

    ini.WriteString("Settings", "UpdateList", "Automatically");
}

function OnClick_radUpdateList2(Sender) {

    ini.WriteString("Settings", "UpdateList", "Prompt");
}

function OnClick_radUpdateList3(Sender) {

    ini.WriteString("Settings", "UpdateList", "Manually");
}

function OnChange_comboProjects(Sender) {

    ComboSelectedProjectName = Sender.Text;
    ComboSelectedProjectRoot = ini.ReadString("Projects", ComboSelectedProjectName, "");

    if(Lowercase(Script.ProjectSettings.SelectedProjectName) == Lowercase(ComboSelectedProjectName))
    {
        lblCurrentProject.Visible = true;

    } else {

        lblCurrentProject.Visible = false;
    }

    listProjectFiles.Items.Clear;
    listProjectOpen.Items.Clear;

    if(Sender.Text != "") // blank entry chosen
    {
        // populate listProjectFile with files from newly selected project
        ini.ReadSection(ComboSelectedProjectName, SL);

        if(SL.Count > 0)
        {
            filename = "";

            for (i=0; i<= SL.Count-1; i++)
            {
                filename = ini.ReadString(ComboSelectedProjectName, SL[i], "");
                listProjectFiles.Items.Add(filename);
            }
        }

        // populate the open file list
        counter = 0;
        filename = "";

        for (i=0; i<Documents.Count; i++)
        {
            var doc = Documents.Tab[i];
            filename = doc.FileName;

            if (Lowercase(copy(filename, 1, Length(ComboSelectedProjectRoot))) == Lowercase(ComboSelectedProjectRoot))
            {
                if (listProjectFiles.Items.IndexOf(filename) == -1)
                {
                    listProjectOpen.Items.Add(filename);
                }
                counter++;
            }
        }
    }
}

function OnClick_btnRemove(Sender) {

    if (listProjectFiles.selCount > 0)
    {
        // have to remove items backwards as list is renumbered on each removal
        for (i=listProjectFiles.Items.Count-1; i>=0; i--)
        {
            if (listProjectFiles.Selected[i] == true)
            {
                listProjectFiles.Items.Delete(i);
            }
        }

        // refresh bottom pane
        listProjectOpen.Items.Clear;

        counter = 0;
        filename = "";

        for (i=0; i<Documents.Count; i++)
        {
            var doc = Documents.Tab[i];
            filename = doc.FileName;

            if (Lowercase(copy(filename, 1, Length(ComboSelectedProjectRoot))) == Lowercase(ComboSelectedProjectRoot))
            {
                if (listProjectFiles.Items.IndexOf(filename) == -1)
                {
                    listProjectOpen.Items.Add(filename);
                }
                counter++;
            }
        }

        // remove and rebuild section
        ini.EraseSection(ComboSelectedProjectName);

        for (i=0; i<listProjectFiles.Items.Count; i++)
        {
            ini.WriteString(ComboSelectedProjectName, i, listProjectFiles.Items[i]);
        }

    } else {

        alert("Project: " + ComboSelectedProjectName + "\n\nNo file was selected.")
    }
}

function OnClick_btnRemoveAll(Sender) {

    if(Confirm("Project: " + ComboSelectedProjectName + "\n\nAre you sure that you wish to remove all?"))
    {
        listProjectFiles.Items.Clear;

        // refresh bottom pane
        listProjectOpen.Items.Clear;

        counter = 0;
        filename = "";

        for (i=0; i<Documents.Count; i++)
        {
            var doc = Documents.Tab[i];
            filename = doc.FileName;

            if (Lowercase(copy(filename, 1, Length(Script.ProjectSettings.SelectedProjectRoot))) == Lowercase(Script.ProjectSettings.SelectedProjectRoot))
            {
                if (listProjectFiles.Items.IndexOf(filename) == -1)
                {
                    listProjectOpen.Items.Add(filename);
                }
                counter++;
            }
        }

        // remove all from ini
        ini.EraseSection(ComboSelectedProjectName);
        ini.DeleteKey("Projects", ComboSelectedProjectName);
    }
}

function OnClick_btnAdd(Sender) {

    if (listProjectOpen.selCount > 0)
    {
        // have to add items backwards as list is renumbered on each removal
        for (i=listProjectOpen.Items.Count-1; i>=0; i--)
        {
            if (listProjectOpen.Selected[i] == true)
            {
                listProjectFiles.Items.Add(listProjectOpen.Items[i]);
                listProjectOpen.Items.Delete(i);
            }
        }

        ini.EraseSection(ComboSelectedProjectName);

        for (i=0; i<listProjectFiles.Items.Count; i++)
        {
            ini.WriteString(ComboSelectedProjectName, i, listProjectFiles.Items[i]);
        }
    } else {

        alert("Project: " + ComboSelectedProjectName + "\n\nNo file was selected.")
    }
}

function OnClick_btnAddAll(Sender) {

    if(Confirm("Project: " + ComboSelectedProjectName + "\n\nAre you sure that you wish to add all?"))
    {
        // have to add items backwards as list is renumbered on each removal
        for (i=listProjectOpen.Items.Count-1; i>=0; i--)
        {
            listProjectFiles.Items.Add(listProjectOpen.Items[i]);
            listProjectOpen.Items.Delete(i);
        }

        ini.EraseSection(ComboSelectedProjectName);

        for (i=0; i<listProjectFiles.Items.Count; i++)
        {
            ini.WriteString(ComboSelectedProjectName, i, listProjectFiles.Items[i]);
        }
    }
}

function OnLeavingProject() {

    exists = ini.SectionExists(Script.ProjectSettings.SelectedProjectName);

    if(exists)
    {
        updateList = ini.ReadString("Settings", "UpdateList", "");

        if(updateList == "Prompt")
        {
            if(Confirm("Project: " + Script.ProjectSettings.SelectedProjectName + "\n\nDo you wish to save a list of the files that are currently open for this project?"))
            {
                SaveProject(Sender);
            }

        } else if(updateList == "Automatically") {

            SaveProject(Sender);
        }
    }

}

function OnSelectingProject() {

    changeProject = ini.ReadString("Settings", "ChangeProject", "");

    if(changeProject == "Prompt")
    {
        if(Confirm("Project: " + Script.ProjectSettings.SelectedProjectName + "\n\nDo you wish to close all open files and open those for this project?"))
        {
            exists = ini.SectionExists(Script.ProjectSettings.SelectedProjectName);

            if(exists)
            {
                CloseOtherProjectsOpenFileList(Sender);

            } else {

                CloseOtherProjects(Sender);
            }
        }

    } else if(changeProject == "Automatically") {

        exists = ini.SectionExists(Script.ProjectSettings.SelectedProjectName);

        if(exists)
        {
            CloseOtherProjectsOpenFileList(Sender);

        } else {

            CloseOtherProjects(Sender);
        }
    }

}

function OpenFileList(Sender) {

    f.Close;

    exists = ini.SectionExists(Script.ProjectSettings.SelectedProjectName);

    if(exists)
    {
        ini.ReadSection(Script.ProjectSettings.SelectedProjectName, SL);

        if(SL.Count > 0)
        {
            var filename = "";

            for (i=0; i<=SL.Count-1; i++)
            {
                filename = ini.ReadString(Script.ProjectSettings.SelectedProjectName, SL[i], "");
                Documents.OpenDocument(filename);
            }

        } else {

            alert("Project: " + Script.ProjectSettings.SelectedProjectName + "\n\nThere is no current file list for this project.");
        }

    } else {

        alert("Project: " + Script.ProjectSettings.SelectedProjectName + "\n\nThere is no current file list for this project.");
    }

}

function CloseOtherProjects(Sender) {

    f.Close;

    filename = "";

    for (i=Documents.Count-1; i>=0; i--)
    {
        doc = Documents.Tab[i];
        filename = doc.FileName;

        if ((Lowercase(copy(filename, 1, Length(Lowercase(Script.ProjectSettings.SelectedProjectRoot))))) != Lowercase(Script.ProjectSettings.SelectedProjectRoot))
        {
            doc.Close(False);
        }
    }

}

function CloseOtherProjectsOpenFileList(Sender) {

    CloseOtherProjects(Sender);
    OpenFileList(Sender);

}

function SaveProject(Sender) {

    f.Close;

    ini.WriteString("Projects", Script.ProjectSettings.SelectedProjectName, Script.ProjectSettings.SelectedProjectRoot);

    counter = 0;
    filename = "";

    ini.EraseSection(Script.ProjectSettings.SelectedProjectName);

    for (i=0; i<Documents.Count; i++)
    {
        var doc = Documents.Tab[i];
        filename = doc.FileName;

        if (Lowercase(copy(filename, 1, Length(Lowercase(Script.ProjectSettings.SelectedProjectRoot)))) == Lowercase(Script.ProjectSettings.SelectedProjectRoot))
        {
            ini.WriteString(Script.ProjectSettings.SelectedProjectName, i, filename);
            counter++;
        }
    }

    if(counter == 0)
    {
        alert("Project: " + Script.ProjectSettings.SelectedProjectName + "\n\n A list of files could not be saved for this project as there were no open files.");

        ini.DeleteKey("Projects", Script.ProjectSettings.SelectedProjectName);

    } else {

        changeProject = ini.ReadString("Settings", "ChangeProject", "");

        if(changeProject != "Automatically")
        {
            alert("Project: " + Script.ProjectSettings.SelectedProjectName + "\n\n " + _t(counter) + " file(s) were saved for this project.");
        }
    }

}

Script.RegisterDocumentAction("", "Project Manager", "", &ProjectManager);

Script.ConnectSignal("project_before_select", &OnLeavingProject);
Script.ConnectSignal("project_after_select", &OnSelectingProject);

Script.RegisterAction("Project Manager", "Open file list", "", &OpenFileList);
Script.RegisterAction("Project Manager", "Close other projects", "", &CloseOtherProjects);
Script.RegisterAction("Project Manager", "Close other projects and open file list", "", &CloseOtherProjectsOpenFileList);
Script.RegisterAction("Project Manager", "Save project", "", &SaveProject);